"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = lane;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _getRemoteByName() {
  const data = _interopRequireDefault(require("../../../remotes/get-remote-by-name"));

  _getRemoteByName = function () {
    return data;
  };

  return data;
}

function lane(_x) {
  return _lane.apply(this, arguments);
}

function _lane() {
  _lane = (0, _bluebird().coroutine)(function* ({
    name,
    remote,
    merged,
    showDefaultLane,
    notMerged
  }) {
    const showMergeData = Boolean(merged || notMerged);

    if (remote) {
      const consumer = yield (0, _consumer().loadConsumerIfExist)();
      const remoteObj = yield (0, _getRemoteByName().default)(remote, consumer);
      const lanes = yield remoteObj.listLanes(name, showMergeData);
      return {
        lanes
      };
    }

    const consumer = yield (0, _consumer().loadConsumer)();
    const lanes = yield consumer.scope.lanes.getLanesData(consumer.scope, name, showMergeData);

    if (showDefaultLane) {
      lanes.push(getLaneDataOfDefaultLane());
    }

    const currentLane = consumer.scope.lanes.getCurrentLaneName();
    return {
      lanes,
      currentLane
    };

    function getLaneDataOfDefaultLane() {
      const bitIds = consumer.bitMap.getAuthoredAndImportedBitIdsOfDefaultLane();
      return {
        name: _constants().DEFAULT_LANE,
        remote: null,
        components: bitIds.map(bitId => ({
          id: bitId,
          head: bitId.version
        })),
        isMerged: null
      };
    }
  });
  return _lane.apply(this, arguments);
}