"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = unTagAction;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _untagComponent() {
  const data = require("../../../scope/component-ops/untag-component");

  _untagComponent = function () {
    return data;
  };

  return data;
}

function _hasWildcard() {
  const data = _interopRequireDefault(require("../../../utils/string/has-wildcard"));

  _hasWildcard = function () {
    return data;
  };

  return data;
}

function _componentsList() {
  const data = _interopRequireDefault(require("../../../consumer/component/components-list"));

  _componentsList = function () {
    return data;
  };

  return data;
}

function unTagAction(_x, _x2, _x3, _x4) {
  return _unTagAction.apply(this, arguments);
}

function _unTagAction() {
  _unTagAction = (0, _bluebird().coroutine)(function* (version, force, persisted, id) {
    const consumer = yield (0, _consumer().loadConsumer)();
    const idHasWildcard = (0, _hasWildcard().default)(id);

    const untag = /*#__PURE__*/function () {
      var _ref = (0, _bluebird().coroutine)(function* () {
        if (idHasWildcard) {
          return (0, _untagComponent().removeLocalVersionsForComponentsMatchedByWildcard)(consumer.scope, version, force, id);
        }

        if (id) {
          const bitId = consumer.getParsedId(id); // a user might run the command `bit untag id@version` instead of `bit untag id version`
          // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

          if (bitId.hasVersion() && !version) version = bitId.version;
          const result = yield (0, _untagComponent().removeLocalVersion)(consumer.scope, bitId, version, force);
          return [result];
        } // untag all


        return (0, _untagComponent().removeLocalVersionsForAllComponents)(consumer.scope, version, force);
      });

      return function untag() {
        return _ref.apply(this, arguments);
      };
    }();

    const softUntag = () => {
      const getIds = () => {
        const componentsList = new (_componentsList().default)(consumer);
        const softTaggedComponents = componentsList.listSoftTaggedComponents();

        if (idHasWildcard) {
          return componentsList.listComponentsByIdsWithWildcard([id]);
        }

        if (id) {
          return [consumer.getParsedId(id)];
        }

        return softTaggedComponents;
      };

      const idsToRemoveSoftTags = getIds();
      return idsToRemoveSoftTags.map(bitId => {
        var _componentMap$nextVer;

        const componentMap = consumer.bitMap.getComponent(bitId, {
          ignoreScopeAndVersion: true
        });
        const removedVersion = (_componentMap$nextVer = componentMap.nextVersion) === null || _componentMap$nextVer === void 0 ? void 0 : _componentMap$nextVer.version;
        if (!removedVersion) return null;
        componentMap.clearNextVersion();
        return {
          id: bitId,
          versions: [removedVersion]
        };
      }).filter(x => x);
    };

    let results;
    const isRealUntag = persisted || consumer.isLegacy;

    if (isRealUntag) {
      results = yield untag();
      yield consumer.scope.objects.persist();
      const components = results.map(result => result.component);
      yield consumer.updateComponentsVersions(components);
    } else {
      // @ts-ignore null was filtered before.
      results = softUntag();
      consumer.bitMap.markAsChanged();
    }

    yield consumer.onDestroy();
    return {
      results,
      isSoftUntag: !isRealUntag
    };
  });
  return _unTagAction.apply(this, arguments);
}