import { CLIArgs, Command, Flags } from './command';
export declare class CommandRunner {
    private command;
    private args;
    private flags;
    constructor(command: Command, args: CLIArgs, flags: Flags);
    runCommand(): Promise<boolean | void | null>;
    private shouldRunRender;
    private runJsonHandler;
    private runRenderHandler;
    private runReportHandler;
    private determineConsoleWritingDuringCommand;
    private writeAndExit;
    private runMigrateIfNeeded;
}
export declare function handleErrorAndExit(err: Error, commandName: string, shouldSerialize?: boolean): boolean | void;
export declare function handleUnhandledRejection(err: Error | null | undefined | {}): boolean | void;
export declare function logErrAndExit(err: Error | string, commandName: string): void;
