"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../api/consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _scopeLanesList() {
  const data = _interopRequireDefault(require("../../../api/scope/lib/scope-lanes-list"));

  _scopeLanesList = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _checkVersionCompatibility() {
  const data = require("../../../scope/network/check-version-compatibility");

  _checkVersionCompatibility = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _clientSupportCompressedCommand() {
  const data = _interopRequireDefault(require("../../../utils/ssh/client-support-compressed-command"));

  _clientSupportCompressedCommand = function () {
    return data;
  };

  return data;
}

let compressResponse;

class ListLanes {
  constructor() {
    (0, _defineProperty2().default)(this, "name", '_lanes <path> <args>');
    (0, _defineProperty2().default)(this, "private", true);
    (0, _defineProperty2().default)(this, "description", 'list lanes');
    (0, _defineProperty2().default)(this, "alias", '');
    (0, _defineProperty2().default)(this, "opts", [['', 'merge-data', 'collect merge data']]);
  }

  action([path, args], {
    mergeData
  }) {
    const {
      payload,
      headers
    } = (0, _utils().unpackCommand)(args);
    compressResponse = (0, _clientSupportCompressedCommand().default)(headers.version);
    (0, _checkVersionCompatibility().checkVersionCompatibilityOnTheServer)(headers.version);

    _logger().default.info('Checking if a migration is needed');

    const scopePath = (0, _utils().fromBase64)(path);
    return (0, _consumer().migrate)(scopePath, false).then(() => {
      return (0, _scopeLanesList().default)(scopePath, payload, mergeData);
    });
  }

  report(str) {
    return (0, _utils().packCommand)((0, _utils().buildCommandMessage)(str, undefined, compressResponse), true, compressResponse);
  }

}

exports.default = ListLanes;