import { DoctorRunAllResults, DoctorRunOneResult } from '../../../api/consumer/lib/doctor';
import Diagnosis from '../../../doctor/diagnosis';
import { CommandOptions, LegacyCommand } from '../../legacy-command';
export default class Doctor implements LegacyCommand {
    name: string;
    description: string;
    alias: string;
    opts: CommandOptions;
    migration: boolean;
    action([diagnosisName]: string[], { list, save, }: {
        list?: boolean;
        save?: string;
    }): Promise<DoctorRunAllResults | Diagnosis[] | DoctorRunOneResult>;
    report(res: DoctorRunAllResults | Diagnosis[], args: any, flags: Record<string, any>): string;
}
