import { SourceFileModel } from '../../../scope/models/version';
import { Repository } from '../../../scope/objects';
import { PathOsBased } from '../../../utils/path';
import AbstractVinyl from './abstract-vinyl';
export default class SourceFile extends AbstractVinyl {
    distFilePath: string | null | undefined;
    static load(filePath: PathOsBased, base: PathOsBased, consumerPath: PathOsBased, extendedProps: Record<string, any>): SourceFile | null;
    static loadFromParsedString(parsedString: Record<string, any>): SourceFile | null;
    static loadFromParsedStringArray(arr: Record<string, any>[]): SourceFile[] | null | undefined;
    static loadFromSourceFileModel(file: SourceFileModel, repository: Repository): Promise<SourceFile>;
    clone(): this;
}
