"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = removeLanes;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _groupArray() {
  const data = _interopRequireDefault(require("group-array"));

  _groupArray = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _enrichContextFromGlobal() {
  const data = _interopRequireDefault(require("../../hooks/utils/enrich-context-from-global"));

  _enrichContextFromGlobal = function () {
    return data;
  };

  return data;
}

function _laneId() {
  const data = require("../../lane-id/lane-id");

  _laneId = function () {
    return data;
  };

  return data;
}

function _remotes() {
  const data = require("../../remotes");

  _remotes = function () {
    return data;
  };

  return data;
}

function _scopeRemotes() {
  const data = require("../../scope/scope-remotes");

  _scopeRemotes = function () {
    return data;
  };

  return data;
}

function _workspaceLane() {
  const data = _interopRequireDefault(require("../bit-map/workspace-lane"));

  _workspaceLane = function () {
    return data;
  };

  return data;
}

function removeLanes(_x, _x2, _x3, _x4) {
  return _removeLanes.apply(this, arguments);
}

function _removeLanes() {
  _removeLanes = (0, _bluebird().coroutine)(function* (consumer, lanes, remote, force) {
    if (remote) {
      const remoteLaneIds = lanes.map(lane => _laneId().RemoteLaneId.parse(lane));
      const results = yield removeRemoteLanes(consumer, remoteLaneIds, force);

      const laneResults = _ramda().default.flatten(results.map(r => r.removedLanes));

      return {
        laneResults
      };
    }

    if (!consumer) throw new Error('consumer must exist for local removal');
    yield consumer.scope.lanes.removeLanes(consumer.scope, lanes, force);
    const workspaceLanes = lanes.map(lane => _workspaceLane().default.load(lane, consumer.scope.path));
    workspaceLanes.forEach(workspaceLane => workspaceLane.reset());
    yield Promise.all(workspaceLanes.map(workspaceLane => workspaceLane.write()));
    return {
      laneResults: lanes
    };
  });
  return _removeLanes.apply(this, arguments);
}

function removeRemoteLanes(_x5, _x6, _x7) {
  return _removeRemoteLanes.apply(this, arguments);
}

function _removeRemoteLanes() {
  _removeRemoteLanes = (0, _bluebird().coroutine)(function* (consumer, lanes, force) {
    const groupedLanesByScope = (0, _groupArray().default)(lanes, 'scope');
    const remotes = consumer ? yield (0, _scopeRemotes().getScopeRemotes)(consumer.scope) : yield _remotes().Remotes.getGlobalRemotes();
    const context = {};
    (0, _enrichContextFromGlobal().default)(context);
    const scope = consumer ? consumer.scope : null;
    const removeP = Object.keys(groupedLanesByScope).map( /*#__PURE__*/function () {
      var _ref = (0, _bluebird().coroutine)(function* (key) {
        const resolvedRemote = yield remotes.resolve(key, scope);
        const idsStr = groupedLanesByScope[key].map(id => id.name);
        return resolvedRemote.deleteMany(idsStr, force, context, true);
      });

      return function (_x8) {
        return _ref.apply(this, arguments);
      };
    }());
    return Promise.all(removeP);
  });
  return _removeRemoteLanes.apply(this, arguments);
}