"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _semver() {
  const data = _interopRequireDefault(require("semver"));

  _semver = function () {
    return data;
  };

  return data;
}

/**
 * Change all the component's version to be a valid semver
 * @param {*} bitMap - The bit map object
 */
function changeVersionToSemVer(bitMap) {
  bitMap.getAllComponents().forEach(componentMap => {
    // In case there is already a semver, do nothing
    const version = componentMap.id.version;

    if (version && !_semver().default.valid(version) && typeof version === 'number') {
      const newVersion = `0.0.${version}`;
      componentMap.id = componentMap.id.changeVersion(newVersion);
    }
  });
  return bitMap;
}

const changeVersionToSemVerDeclartaion = {
  name: 'change bit map versions to SemVer',
  migrate: changeVersionToSemVer
};
var _default = changeVersionToSemVerDeclartaion;
exports.default = _default;