"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _npmClient() {
  const data = _interopRequireDefault(require("../../npm-client"));

  _npmClient = function () {
    return data;
  };

  return data;
}

function _diagnosis() {
  const data = _interopRequireDefault(require("../diagnosis"));

  _diagnosis = function () {
    return data;
  };

  return data;
}

class ValidateNpmExec extends _diagnosis().default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2().default)(this, "name", 'validate npm exec');
    (0, _defineProperty2().default)(this, "description", 'validate that npm executable found');
    (0, _defineProperty2().default)(this, "category", 'vendors');
  }

  _formatSymptoms() {
    return 'npm executable not found';
  }

  _formatManualTreat() {
    return 'please ensure npm is installed';
  }

  _runExamine() {
    return (0, _bluebird().coroutine)(function* () {
      const npmVersion = yield _npmClient().default.getNpmVersion();

      if (npmVersion) {
        return {
          valid: true
        };
      }

      return {
        valid: false,
        data: {}
      };
    })();
  }

}

exports.default = ValidateNpmExec;