export declare type ExamineBareResult = {
    valid: boolean;
    data?: Record<string, any>;
};
export declare type DiagnosisMetaData = {
    name: string;
    description: string;
    category: string;
};
export declare type ExamineResult = {
    diagnosisMetaData: DiagnosisMetaData;
    bareResult: ExamineBareResult;
    formattedSymptoms: string;
    formattedManualTreat: string;
};
export default class Diagnosis {
    name: string;
    description: string;
    category: string;
    result: Record<string, any>;
    _runExamine(): Promise<ExamineBareResult>;
    _formatSymptoms(bareResult: ExamineBareResult): string;
    _formatManualTreat(bareResult: ExamineBareResult): string;
    getMeta(): {
        category: string;
        name: string;
        description: string;
    };
    examine(): Promise<ExamineResult>;
}
