import execa from 'execa';
export declare type InteractiveInputs = InteractiveInputDefinition[];
export declare type InteractiveInputDefinition = {
    triggerText: string;
    inputs: InteractiveInput[];
};
export declare type InteractiveInput = {
    value: string | InteractiveKey;
    waitInput?: number;
};
export declare type InteractiveKey = {
    label: string;
    value: string;
};
export declare type InteractiveKeyName = 'up' | 'down' | 'enter' | 'space';
declare type InteractiveKeys = {
    [key in InteractiveKeyName]: InteractiveKey;
};
export declare const INTERACTIVE_KEYS: InteractiveKeys;
declare const _default: ({ processName, args, inputs, processOpts, opts, }: {
    processName: string;
    args: string[];
    inputs: InteractiveInputs;
    processOpts: Record<string, any>;
    opts: {
        defaultIntervalBetweenInputs: number;
        verbose: boolean;
    };
}) => Promise<execa.ExecaReturnValue<string>>;
export default _default;
