export default class LaneId {
    readonly name: string;
    readonly scope?: string | null;
    constructor({ name, scope }: {
        name: string;
        scope?: string | null;
    });
    hasSameName(id: LaneId): boolean;
    hasSameScope(id: LaneId): boolean;
    isEqual(laneId: LaneId): boolean;
    isDefault(): boolean;
    toString(): string;
    static from(name: string, scope?: string | null): LaneId;
}
export declare class RemoteLaneId extends LaneId {
    constructor({ name, scope }: {
        name: string;
        scope: string;
    });
    set scope(scope: string);
    static from(name: string, scope: string): RemoteLaneId;
    static parse(id: string): RemoteLaneId;
}
export declare class LocalLaneId extends LaneId {
    constructor({ name }: {
        name: string;
    });
    static from(name: string): LocalLaneId;
}
