import { FETCH_OPTIONS } from '../api/scope/lib/fetch';
import { BitId } from '../bit-id';
import DependencyGraph from '../scope/graph/scope-graph';
import { ObjectList } from '../scope/objects/object-list';
import Scope from '../scope/scope';
import Remote from './remote';
export default class Remotes extends Map<string, Remote> {
    constructor(remotes?: [string, Remote][]);
    validate(): void;
    resolve(scopeName: string, thisScope?: Scope | null | undefined): Promise<Remote>;
    isHub(scope: any): boolean;
    fetch(idsGroupedByScope: {
        [scopeName: string]: string[];
    }, thisScope: Scope, options?: Partial<FETCH_OPTIONS>, context?: Record<string, any>): Promise<ObjectList>;
    latestVersions(ids: BitId[], thisScope: Scope): Promise<BitId[]>;
    scopeGraphs(ids: BitId[], thisScope: Scope): Promise<DependencyGraph[]>;
    _groupByScopeName(ids: BitId[]): {
        [scopeName: string]: BitId[];
    };
    toPlainObject(): {};
    static getScopeRemote(scopeName: string): Promise<Remote>;
    static getGlobalRemotes(): Promise<Remotes>;
    static load(remotes: {
        [key: string]: string;
    }): Remotes;
}
