import { BitId, BitIds } from '../../bit-id';
import ConsumerComponent from '../../consumer/component';
import Consumer from '../../consumer/consumer';
import { Lane, ModelComponent, Symlink } from '../models';
import RemovedObjects from '../removed-components';
import Scope from '../scope';
export default class RemoveModelComponents {
    scope: Scope;
    bitIds: BitIds;
    force: boolean;
    removeSameOrigin: boolean;
    consumer: Consumer | null | undefined;
    currentLane: Lane | null;
    constructor(scope: Scope, bitIds: BitIds, force: boolean, removeSameOrigin: boolean, consumer?: Consumer);
    setCurrentLane(): Promise<void>;
    remove(): Promise<RemovedObjects>;
    _removeSingle(bitId: BitId): Promise<{
        bitId: BitId;
        removedDependencies: BitIds;
    }>;
    _removeComponentsDependencies(dependentBits: Record<string, any>, componentList: Array<ModelComponent | Symlink>, consumerComponentToRemove: ConsumerComponent, bitId: BitId): Promise<BitIds>;
    _removeComponent(id: BitId, componentList: Array<ModelComponent | Symlink>): Promise<void>;
}
