import { Graph as GraphLib } from 'graphlib';
import { Scope } from '..';
import { BitId, BitIds } from '../../bit-id';
import { Consumer } from '../../consumer';
import Component from '../../consumer/component/consumer-component';
import ComponentWithDependencies from '../component-dependencies';
import { ComponentsAndVersions } from '../scope';
import Graph from './graph';
export declare type AllDependenciesGraphs = {
    graphDeps: GraphLib;
    graphDevDeps: GraphLib;
    graphExtensionDeps: GraphLib;
};
export declare function buildComponentsGraph(components: Component[]): AllDependenciesGraphs;
export declare function buildComponentsGraphForComponentsAndVersion(components: ComponentsAndVersions[]): AllDependenciesGraphs;
export declare function buildOneGraphForComponentsAndMultipleVersions(components: ComponentsAndVersions[]): Graph;
export declare function buildOneGraphForComponents(ids: BitId[], consumer: Consumer, direction?: 'normal' | 'reverse', loadComponentsFunc?: (ids: BitId[]) => Promise<Component[]>, ignoreIds?: BitIds): Promise<Graph>;
export declare function buildOneGraphForComponentsUsingScope(ids: BitId[], scope: Scope, direction?: 'normal' | 'reverse'): Promise<Graph>;
export declare function topologicalSortComponentDependencies(componentWithDependencies: ComponentWithDependencies): void;
