import { Graph as GraphLib } from 'graphlib';
import { BitId } from '../../bit-id';
import Component from '../../consumer/component';
import Consumer from '../../consumer/consumer';
import { ModelComponent, Version } from '../models';
import Scope from '../scope';
export default class Graph extends GraphLib {
    getSuccessorsByEdgeTypeRecursively(bitId: string, successorsList?: string[], visited?: {
        [key: string]: boolean;
    }): string[];
    findSuccessorsInGraph(ids: string[]): Component[];
    getBitIdsIncludeVersionsFromGraph(ids: BitId[], graph: Graph): BitId[];
    static buildGraphFromScope(scope: Scope): Promise<Graph>;
    static _addDependenciesToGraph(id: BitId, graph: Graph, component: Version | Component): void;
    static addScopeComponentsAsNodes(allModelComponents: ModelComponent[], graph: Graph, workspaceComponents?: Component[], onlyLatest?: boolean): Promise<void>;
    static buildGraphFromWorkspace(consumer: Consumer, onlyLatest?: boolean): Promise<Graph>;
}
