"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function componentMigrations() {
  const data = _interopRequireWildcard(require("./component"));

  componentMigrations = function () {
    return data;
  };

  return data;
}

function versionMigrations() {
  const data = _interopRequireWildcard(require("./component-version"));

  versionMigrations = function () {
    return data;
  };

  return data;
}

/**
 * A file to define the list of migration needs to be run for each version
 */
var _default = {
  '0.11.0': {
    Component: [componentMigrations().changeVersionToSemVerDeclartaion],
    Version: [versionMigrations().implSpecsToFilesDeclartaion, versionMigrations().specsResultstoArrayDeclartaion, versionMigrations().addBindingPrefixDeclartaion, versionMigrations().changeVersionToSemVerDeclartaion]
  },
  '0.11.1': {
    Version: [versionMigrations().changeImportSpecifiersToArray, versionMigrations().ensureMainFileDeclartaion]
  },
  '0.12.0': {
    Component: [componentMigrations().updateBindingPrefixToNewDefault],
    Version: [versionMigrations().updateBindingPrefixToNewDefault]
  },
  '0.12.1': {
    Version: [versionMigrations().removeLatestFromCompiler]
  }
};
exports.default = _default;