/// <reference types="node" />
import { BitId } from '../../bit-id';
import BitObject from '../objects/object';
export declare type SymlinkProp = {
    scope: string;
    name: string;
    realScope: string;
};
export default class Symlink extends BitObject {
    scope: string;
    name: string;
    realScope: string;
    constructor(props: SymlinkProp);
    id(): string;
    getRealComponentId(): BitId;
    static parse(contents: Buffer): Symlink;
    toObject(): {
        scope: string;
        name: string;
        realScope: string;
    };
    toBitId(): BitId;
    toBuffer(pretty?: boolean): Buffer;
    static from(props: SymlinkProp): Symlink;
}
