import { Network } from '../network';
import { BitId, BitIds } from '../../../bit-id';
import Component from '../../../consumer/component';
import { ListScopeResult } from '../../../consumer/component/components-list';
import DependencyGraph from '../../graph/scope-graph';
import { LaneData } from '../../lanes/lanes';
import { ComponentLogs } from '../../models/model-component';
import { ScopeDescriptor } from '../../scope';
import { ObjectList } from '../../objects/object-list';
import { FETCH_OPTIONS } from '../../../api/scope/lib/fetch';
export declare class Http implements Network {
    private scopeUrl;
    constructor(scopeUrl: string);
    private _token;
    get token(): string | undefined;
    get graphqlUrl(): string;
    close(): void;
    describeScope(): Promise<ScopeDescriptor>;
    deleteMany(ids: string[], force: boolean, context: Record<string, any>, idsAreLanes: boolean): Promise<any>;
    pushMany(objectList: ObjectList): Promise<string[]>;
    fetch(ids: string[], fetchOptions: FETCH_OPTIONS): Promise<ObjectList>;
    private throwForNonOkStatus;
    private getHeaders;
    list(namespacesUsingWildcards?: string | undefined): Promise<ListScopeResult[]>;
    show(bitId: BitId): Promise<Component | null | undefined>;
    deprecateMany(ids: string[]): Promise<Record<string, any>[]>;
    undeprecateMany(ids: string[]): Promise<Record<string, any>[]>;
    log(id: BitId): Promise<ComponentLogs>;
    latestVersions(bitIds: BitIds): Promise<string[]>;
    graph(): Promise<DependencyGraph>;
    listLanes(name?: string | undefined, mergeData?: boolean | undefined): Promise<LaneData[]>;
    static connect(host: string): Promise<Http>;
}
