"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function readKey(_x) {
  return _readKey.apply(this, arguments);
}

function _readKey() {
  _readKey = (0, _bluebird().coroutine)(function* (keyPath) {
    if (!keyPath) return '';

    try {
      const fileBuffer = yield _fsExtra().default.readFile(keyPath);
      return fileBuffer;
    } catch (e) {
      return '';
    }
  });
  return _readKey.apply(this, arguments);
}

var _default = /*#__PURE__*/function () {
  var _keyGetter = (0, _bluebird().coroutine)(function* (keyPath) {
    if (keyPath) return readKey(keyPath);
    const sshFile = yield (0, _utils().identityFile)();

    _logger().default.debug(`ssh, reading ssh key at ${sshFile}`);

    return readKey(sshFile);
  });

  function keyGetter(_x2) {
    return _keyGetter.apply(this, arguments);
  }

  return keyGetter;
}();

exports.default = _default;