import { BitIds } from '../bit-id';
import { BitIdStr } from '../bit-id/bit-id';
export declare type RemovedObjectSerialized = {
    removedComponentIds: BitIdStr[];
    missingComponents: BitIdStr[];
    removedDependencies: BitIdStr[];
    dependentBits: Record<string, any>;
    removedFromLane?: boolean;
    removedLanes: string[];
};
export default class RemovedObjects {
    removedComponentIds: BitIds;
    missingComponents: BitIds;
    removedDependencies: BitIds;
    dependentBits: Record<string, any>;
    removedFromLane: boolean;
    removedLanes: string[];
    constructor({ removedComponentIds, missingComponents, removedDependencies, dependentBits, removedFromLane, removedLanes, }: {
        removedComponentIds?: BitIds;
        missingComponents?: BitIds;
        removedDependencies?: BitIds;
        dependentBits?: Record<string, any>;
        removedFromLane?: boolean;
        removedLanes?: string[];
    });
    serialize(): RemovedObjectSerialized;
    static fromObjects(payload: {
        removedComponentIds: string[];
        missingComponents: string[];
        removedDependencies: string[];
        dependentBits: {
            [key: string]: Record<string, any>[];
        };
        removedLanes: string[];
    }): RemovedObjects;
}
