import { ManipulateDirItem } from '../consumer/component-ops/manipulate-dir';
import ComponentWithDependencies from './component-dependencies';
import ComponentVersion from './component-version';
import { ObjectItem } from './objects/object-list';
import Repository from './objects/repository';
export default class VersionDependencies {
    component: ComponentVersion;
    dependencies: ComponentVersion[];
    devDependencies: ComponentVersion[];
    extensionsDependencies: ComponentVersion[];
    allDependencies: ComponentVersion[];
    sourceScope: string | null | undefined;
    constructor(component: ComponentVersion, dependencies: ComponentVersion[], devDependencies: ComponentVersion[], extensionsDependencies: ComponentVersion[], sourceScope: string);
    toConsumer(repo: Repository, manipulateDirData: ManipulateDirItem[] | null | undefined): Promise<ComponentWithDependencies>;
    toObjects(repo: Repository, clientVersion: string | null | undefined, collectParents: boolean, collectArtifacts: boolean): Promise<ObjectItem[]>;
}
