"use strict";

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _chai() {
  const data = require("chai");

  _chai = function () {
    return data;
  };

  return data;
}

function _sleep() {
  const data = require("../sleep");

  _sleep = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("./exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _timer() {
  const data = require("./timer");

  _timer = function () {
    return data;
  };

  return data;
}

describe('Timer', () => {
  it('should stop after 100ms', /*#__PURE__*/(0, _bluebird().coroutine)(function* () {
    const timer = _timer().Timer.create();

    timer.start();
    yield (0, _sleep().sleep)(50);
    const {
      elapsed
    } = timer.stop();
    (0, _chai().expect)(elapsed < 100).to.equal(true);
  }));
  it('should return elapsed in seconds', /*#__PURE__*/(0, _bluebird().coroutine)(function* () {
    const timer = _timer().Timer.create();

    timer.start();
    yield (0, _sleep().sleep)(50);
    const {
      seconds
    } = timer.stop();
    (0, _chai().expect)(seconds < 1).to.equal(true);
  }));
  it('should throw an error if invoking stop without starting', () => {
    (0, _chai().expect)(() => {
      const timer = _timer().Timer.create();

      timer.stop();
    }).to.throw(_exceptions().TimerNotStarted);
  });
  it('should throw an error if invoking start twice', () => {
    (0, _chai().expect)(() => {
      const timer = _timer().Timer.create();

      timer.start();
      timer.start();
    }).to.throw(_exceptions().TimerAlreadyRunning);
  });
});