"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = sha1;

function crypto() {
  const data = _interopRequireWildcard(require("crypto"));

  crypto = function () {
    return data;
  };

  return data;
}

/**
 * encrypt `data` buffer or string into a sha1 hash
 * @example
 * ```js
 *  sha1('foo bar') // => '3773dea65156909838fa6c22825cafe090ff8030'
 * ```
 */
function sha1(data, encoding = 'hex') {
  return crypto().createHash('sha1').update(data).digest(encoding);
}