"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = calculateFileInfo;

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

/**
 * get the current working dir name of file and file name.
 * @name fileInfo
 * @param relativePath
 * @returns {object}
 * @example
 * ```js
 *  currentDirName() // => 'bit'
 * ```
 */
function calculateFileInfo(relativePath) {
  const fileInfo = path().parse(relativePath);
  const fullPath = path().dirname(relativePath);
  const rootDir = path().dirname(fullPath);
  const parentDir = path().relative(rootDir, fullPath);
  return {
    PARENT: parentDir,
    FILE_NAME: fileInfo.name
  };
}