"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = moveSync;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function () {
    return data;
  };

  return data;
}

function _generalError() {
  const data = _interopRequireDefault(require("../../error/general-error"));

  _generalError = function () {
    return data;
  };

  return data;
}

function moveSync(src, dest, options) {
  if (!(0, _path().isAbsolute)(src) || !(0, _path().isAbsolute)(dest)) {
    throw new Error(`moveSync, src and dest must be absolute. Got src "${src}", dest "${dest}"`);
  }

  try {
    _fsExtra().default.moveSync(src, dest, options);
  } catch (err) {
    if (err.message.includes('Cannot move') && err.message.includes('into itself')) {
      throw new (_generalError().default)(`unable to move '${src}' into itself '${dest}'`);
    }

    throw err;
  }
}