"use strict";

require("core-js/modules/es.string.trim");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Convert a boolean from a string or boolean, return default value in case of null or undefined
 */
var toBoolean = function toBoolean(value, defaultValue) {
  if (value === null || value === undefined) {
    return defaultValue;
  }

  const valueAsString = String(value).trim().toLowerCase();

  if (valueAsString === 'true') {
    return true;
  }

  if (valueAsString === 'false') {
    return false;
  }

  return defaultValue;
};

exports.default = toBoolean;